## Chapter 5, Ex. 5.4


postscript("Fig53.ps", width=4.4, height=4.8, horizontal=F, pointsize=8)
par(mfrow = c(2, 2),mar=c(3,2,2,1)+0.1, cex=0.8)

### process .csv (from Yahoo Finance) to .RData
#rm(list=ls())
#setwd("C:/Course/ORF504 Financial Econometrics/Spring 2011/Projects/4.4")
RawData = read.csv("RawData.csv")
#save(RawData, file="4_4.RData")


### CAPM regression

#  monthly excess log returns.
RawData60 = RawData[1:61,]
attach(RawData60)
RFrate = rev( 100 * ( ( 1+ IRX[1:(length(IRX)-1)] / 100  )^(1/12) - 1 ) )
GSexr = diff(log(rev(GS))) * 100 - RFrate 
GEexr =  diff(log(rev(GE))) * 100  - RFrate 
IBMexr = diff(log(rev(IBM))) * 100 - RFrate  
SPXexr = diff(log(rev(SPX)))* 100   - RFrate 



# CAPM regression and plots
GSbeta = lsfit(SPXexr, GSexr)$coef
GSbeta
plot(SPXexr, GSexr, xlab="", ylab="", main="GS",pch=16,col=4,lwd=2)
abline(GSbeta, lwd=2, col=2)
legend("bottomright","beta=1.37", bty="n")

IBMbeta = lsfit(SPXexr, IBMexr)$coef
IBMbeta
plot(SPXexr, IBMexr, xlab="", ylab="", main="IBM", pch=16,col=4,lwd=2)
abline(IBMbeta,lwd=2,col=2)
legend("bottomright","beta=0.74", bty="n")

GEbeta = lsfit(SPXexr, GEexr)$coef
GEbeta
plot(SPXexr, GEexr, xlab="", ylab="", main="GE", pch=16, col=4, lwd=2)
abline(GEbeta, lwd=2, col=2)
legend("bottomright","beta=1.66", bty="n")



## 4th plot: rolling CAPM beta for GE
attach(RawData)
RFrate = 100 * ( ( 1+ IRX[1:(length(IRX)-1)] / 100  )^(1/12) - 1 )
GEexr = rev( diff(log(GE)) * 100  - RFrate )
SPXexr = rev( diff(log(SPX))* 100  - RFrate )

T = 60
Twin = 60
Tstart = length(GEexr) - T + 1
betaRoll = rep(0,T)
for (t in 1:T)
{
  GEroll = GEexr[(Tstart+t-Twin):(Tstart+t-1)]
  SPXroll =  SPXexr[(Tstart+t-Twin):(Tstart+t-1)]
  betaRoll[t] = lsfit(SPXroll, GEroll)$coef[2]
}
tsbeta = ts(data = betaRoll, frequency=12, end = c(2011,2))
plot(tsbeta, type="l", xlab = "", ylab="", main="GE time-varying beta",
col=4, lwd=2 )

dev.off()


rm(list=ls())
#setwd("C:/Course/ORF504 Financial Econometrics/Spring 2011/Projects/4.4")
RawData = read.csv("RawData.csv")
attach(RawData)


